function love.load()

	love.graphics.setDefaultFilter("nearest", "nearest")
	scale = 2
	
	--shield charge: line at the bottom of brackets, lshift to activate. It drains slowly over time
	--health regen: every 10 points
	
	graphics = {}
	audio = {}

	requireFiles("") --start recursiveness!

	loadFonts()

	quads = {}

	graphics["ship"] = love.graphics.newImage("graphics/ship/space_ship.png")
	quads["ship"] = {}
	for k = 1, 4 do
		quads["ship"][k] = {}
		for y = 1, 4 do
			quads["ship"][k][y] = love.graphics.newQuad((k-1) * 41, (y - 1) * 40, 40, 40, graphics["ship"]:getWidth(), graphics["ship"]:getHeight())
		end
	end

	graphics["fruit"] = love.graphics.newImage("graphics/enemies/fruits.png")
	quads["fruit"] = {}
	for k = 1, graphics["fruit"]:getWidth()/23 do
		quads["fruit"][k] = love.graphics.newQuad((k-1)*23, 0, 22, 22, graphics["fruit"]:getWidth(), graphics["fruit"]:getHeight())
	end

	graphics["health"] = love.graphics.newImage("graphics/hud/Health.png")
	graphics["hurt"] = love.graphics.newImage("graphics/hud/Health_Broken.png")

	graphics["splat"] = love.graphics.newImage("graphics/enemies/explosion_quad.png")
	quads["splat"] = {}
	for k = 1, 6 do
		quads["splat"][k] = love.graphics.newQuad((k-1)*24, 0, 22, 22, graphics["splat"]:getWidth(), graphics["splat"]:getHeight())
	end

	graphics["powerups"] = love.graphics.newImage("graphics/items/power_ups_quad.png")
	quads["powerups"] = {}
	for k = 1, 3 do
		quads["powerups"][k] = love.graphics.newQuad((k-1)*24, 0, 16, 16, graphics["powerups"]:getWidth(), graphics["powerups"]:getHeight())
	end

	graphics["grapepiece"] = love.graphics.newImage("graphics/enemies/grape_piece.png")

	staticBGs = {love.graphics.newImage("graphics/bg/moon.png"), love.graphics.newImage("graphics/bg/planet.png"), love.graphics.newImage("graphics/bg/sun.png"), love.graphics.newImage("graphics/bg/satalite.png"), 
				love.graphics.newImage("graphics/bg/blackhole.png"), love.graphics.newImage("graphics/bg/astroid_1.png"), love.graphics.newImage("graphics/bg/astroid_2.png"), love.graphics.newImage("graphics/bg/earth.png")}

	bulletimg = love.graphics.newImage("graphics/ship/bullet.png")

	graphics["powerup"] = love.graphics.newImage("graphics/items/power_ups_quad.png")
	quads["powerups"] = {}
	for k = 1, graphics["powerup"]:getWidth()/17 do
		quads["powerups"][k] = love.graphics.newQuad((k-1)*17, 0, 16, 16, graphics["powerup"]:getWidth(), graphics["powerup"]:getHeight())
	end


	love.window.setTitle("Codename: Space Fruit")
	love.window.setMode(800, 600)

	love.graphics.setFont(title)
	love.graphics.setPointStyle("rough")

	bgm = love.audio.newSource("sound/bgm.ogg", "stream")
	bgm:setLooping(true)

	gameoversnd = love.audio.newSource("sound/gameover.ogg")

	damage = {love.audio.newSource("sound/explosion_1.ogg"), love.audio.newSource("sound/explosion_2.ogg")}
	shoot = {love.audio.newSource("sound/shoot_1.ogg"), love.audio.newSource("sound/shoot_2.ogg")}
	fruitboom = {love.audio.newSource("sound/fruit_explode_1.ogg"), love.audio.newSource("sound/fruit_explode_2.ogg"), love.audio.newSource("sound/fruit_explode_3.ogg")}
	gameoversong = {love.audio.newSource("sound/title.ogg")}
	game_load()
end

function love.focus(focus)
	paused = not focus
end

function saveLoadHighscore(load)
	if not load then
		if gamescore > highscore then
			love.filesystem.write("highscore.txt", gamescore)
		end
	else
		local data = love.filesystem.read("highscore.txt")
		highscore = tonumber(data)
	end
end

function love.update(dt)
	dt = math.min(1/60, dt)
	
	if _G[state .. "_update"] then
		_G[state .. "_update"](dt)
	end
end

function love.draw()
	love.graphics.scale(scale, scale)

	if _G[state .. "_draw"] then
		_G[state .. "_draw"]()
	end
end

function love.keypressed(key)
	if _G[state .. "_keypressed"] then
		_G[state .. "_keypressed"](key)
	end
end

function love.keyreleased(key)
	if _G[state .. "_keyreleased"] then
		_G[state .. "_keyreleased"](key)
	end
end

function requireFiles(path)
	local f = love.filesystem.getDirectoryItems(path)

	for k = 1, #f do
		if love.filesystem.isDirectory(f[k]) then
			requireFiles(f[k] .. "/")
		else
			if f[k]:sub(-4) == ".lua" then
				require(path .. f[k]:gsub(".lua", ""))
			end
		end
	end
end

function loadFonts()
	title = love.graphics.newFont("graphics/ARCADE_N.TTF", 16)
	hudfont = love.graphics.newFont("graphics/ARCADE_N.TTF", 8)
end